/*
 *This code is made for controling model trains using a 2.4ghz reciver
 *Krump's Projects created 3/29/2022
 *This version made to handle controling multiple trains and slot cars at one time.
 *Logic Cleaned Untested 3/20/2025
 *            
 *Base Code credits to
 * by Dejan Nedelkovski, www.HowToMechatronics.com  https://howtomechatronics.com/tutorials/arduino/arduino-wireless-communication-nrf24l01-tutorial/
 * Using the Library: TMRh20/RF24, https://github.com/tmrh20/RF24/  //search in arduino library manager for rf24
*/

//Used in RF chip interface
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
RF24 radio(7, 8); // CE, CSN
const byte address[6] = "00001";

void setup() {
  Serial.begin(9600);
  pinMode(2, INPUT_PULLUP);//Train 1 reversing switch
  pinMode(3, INPUT_PULLUP);//Train 2 reversing switch
  pinMode(4, INPUT_PULLUP);//Train 3 reversing swtich

  //Used for RF chip
  radio.begin();
  radio.openWritingPipe(address);
  radio.setPALevel(RF24_PA_MIN);
  radio.stopListening();
}


void loop() {

  for (int cab = 1; cab < 3; cab++) {  //calls train control method for cabs 1-3
    train(cab);
  }

  // slot(); //Calls slot car control method

  // if(digitalRead(3)==LOW){      //A button for sending horn command to train 1, Needs debouncing logic to work well
  //   int g = 1600;
  //   radio.write(&g, sizeof(g));
  // }

  delay(100);
}

void train(int cab){
  int v = analogRead(cab-1);    //Read pot throttle value. Throttle pots connected to A0-A2
  v = map(v, 0, 1023, 0, 255);  //Map from analog in value to h-bridge analog write range
  v = (cab * 1000) + v;         //Add the thousands place cab id value
  if(digitalRead(cab+1) == LOW){
    v = v * -1;                 //If the reversing switch is thrown make negative for reverse
  }
  radio.write(&v, sizeof(v));   //Write the value to the radio for sending to the train
  Serial.println(v);            //Print to computer to see what values are being sent for debugging
}

void slot(){    //Used to control the hbrige running the slot car track
  int s=analogRead(1);
  s = map(s,0, 1023, 0, 255);
  analogWrite(9,s);
  s=analogRead(2);
  s = map(s,0, 1023, 0, 255);
  analogWrite(10,s);
}
